package cz.majner.chata.nasechata;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
//import android.widget.Toast;

import java.text.DateFormat;
import java.util.Date;



public class FragmentQuido extends Fragment {

    private final static String CONNECTIVITY = "android.net.conn.CONNECTIVITY_CHANGE";
    public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";
    //private static final String SAVED_BUNDLE_TAG = "cz.majner.chata.nasechata.saved_bundle";
    //--MyObject myObject;
    //private Bundle savedState = null;
    //private boolean createdStateInDestroyView;

    private ConnectivityManager cm;
    private TextView popisQuidoInternetStav, textViewQuidoStav, popisQuidoVchodStav, popisQuidoVerandaStav,
            textViewQuidoHistory;
    private Button buttonQuidoStav, buttonQuidoVerandaZap, buttonQuidoVerandaVyp, buttonQuidoVchodZap,
            buttonQuidoVchodVyp, buttonQuidoSvetloZap, buttonQuidoSvetloVyp;
    SharedPreferences preferences;


    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action.equals(CONNECTIVITY)) {
                updateNetworkStatus();
            }
            if (action.equals(NOTIFICATION)) {
                String button_status = intent.getStringExtra("button_status");
                if (button_status.equals("false")) {
                    nastavQuidoButtony(false);
                }
                if (button_status.equals("true")) {
                    nastavQuidoButtony(true);
                }
                //buttonOdeslat.setEnabled(true);
            }
            if (action.equals(NOTIFICATION + ".QUIDO")) {
                String vysledek = intent.getStringExtra("vysledek");
                //String histore = "HISTORIE\n";
                //String vys = preferences.getString("vysledek.QUIDO", "");

                zpracujQuidoVysledek(vysledek);

            }

        }
    };


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Get the view from fragmenttab1.xml

        super.onCreateView(inflater, container, savedInstanceState);
        //setRetainInstance( )
        //Toast.makeText(getActivity(), "CreateView",Toast.LENGTH_SHORT).show();


        View view = inflater.inflate(R.layout.fragment_quido, container, false);

        popisQuidoInternetStav = (TextView) view.findViewById(R.id.popisPocasiInternetStav);
        textViewQuidoHistory = (TextView) view.findViewById(R.id.textViewQuidoHistory);
        popisQuidoVchodStav = (TextView) view.findViewById(R.id.popisQuidoVchodStav);
        popisQuidoVerandaStav = (TextView) view.findViewById(R.id.popisQuidoVerandaStav);
        textViewQuidoStav = (TextView) view.findViewById(R.id.textViewPocasiStav);
        buttonQuidoStav = (Button) view.findViewById(R.id.buttonPocasiStav);
        buttonQuidoVerandaZap = (Button) view.findViewById(R.id.buttonQuidoVerandaZap);
        buttonQuidoVerandaVyp = (Button) view.findViewById(R.id.buttonQuidoVerandaVyp);
        buttonQuidoVchodZap = (Button) view.findViewById(R.id.buttonQuidoVchodZap);
        buttonQuidoVchodVyp = (Button) view.findViewById(R.id.buttonQuidoVchodVyp);
        buttonQuidoSvetloZap = (Button) view.findViewById(R.id.buttonQuidoSvetloZap);
        buttonQuidoSvetloVyp = (Button) view.findViewById(R.id.buttonQuidoSvetloVyp);

       /*
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        String value = preferences.getString("PAUSE",null);

        if (savedInstanceState != null)
        {
            obnovStavQuidoView (savedInstanceState);
            preferences.edit().putString ("PAUSE", "normal").apply();
        }

        if (value != null) {
            // handle the value
            if (value.equals("PAUSE")) {
                //Toast.makeText(getActivity(), "PPP",Toast.LENGTH_LONG).show();
                preferences.edit().putString ("PAUSE", "normal").apply();
                obnovStavQuidoViewPref(preferences);
            }
        }
        */
        buttonQuidoStav.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // Do something in response to button click
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                //ZvolenyPrikaz = String.valueOf(spinnerPrikaz.getSelectedItem());
                //poslat dotaz na server
                builder.appendQueryParameter("prikaz", "SVETLO INFO");
                //builder.appendQueryParameter("prikaz", ZvolenyPrikaz);
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });

        buttonQuidoVchodZap.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "ROZSVITIT VCHOD");
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });

        buttonQuidoVchodVyp.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "ZHASNOUT VCHOD");
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });
        buttonQuidoVerandaZap.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "ROZSVITIT VERANDU");
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });
        buttonQuidoVerandaVyp.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "ZHASNOUT VERANDU");
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });

        buttonQuidoSvetloZap.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "ROZSVITIT SVETLO");
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });

        buttonQuidoSvetloVyp.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                textViewQuidoHistory.setText("Čekám na odpověď...");
                preferences.edit().putString("textViewQuidoStavLastOK", textViewQuidoStav.getText().toString()).apply();
                textViewQuidoStav.setText("Aktualizuji stav...");
                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "ZHASNOUT SVETLO");
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampQuido = System.currentTimeMillis();
                preferences.edit().putLong("timestampQuido", timestampQuido).apply();
                preferences.edit().putBoolean("progressQuido", true).apply();
                new ChataRemoteRequest(getActivity(), "QUIDO", timestampQuido).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });


        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        //Boolean butt=preferences.getBoolean("buttons", true);
        //String toustik= "Reason:" + QuidoTerminateReason + "\n"+progressQuido.toString()+ "\n"+butt.toString()+ "\n"+commandID+ "="+ timestampQuido+ "\n"+vysledek;
        //Toast.makeText(getActivity(), "resume", Toast.LENGTH_SHORT).show();

        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION));
        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION + ".QUIDO"));
        getActivity().registerReceiver(receiver, new IntentFilter(CONNECTIVITY));
        cm = (ConnectivityManager) getActivity().getSystemService(Context.CONNECTIVITY_SERVICE);
        updateNetworkStatus();

        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //String QuidoTerminateReason = preferences.getString("QuidoTerminateReason", null);

        //osetrit pripad, kdy obnovuji stav pri spustenem dotazu ChataRemoteRequest
        //v opacnem pripade obycejne obnoveni
        obnovStavQuidoViewPref();
         Long commandID = preferences.getLong("commandID.QUIDO", 0);
        Long timestampQuido = preferences.getLong("timestampQuido", 1);
        String vysledek = preferences.getString("vysledek.QUIDO", "");
        Boolean progressQuido = preferences.getBoolean("progressQuido", false);
        if (progressQuido && commandID.equals(timestampQuido)) {
            zpracujQuidoVysledek(vysledek);
            //Toast.makeText(getActivity(),"zpracovavam", Toast.LENGTH_LONG).show();
        }

    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        //getActivity().unregisterReceiver(receiver);
        //Toast.makeText(getActivity(), "Destroy",Toast.LENGTH_SHORT).show();
    }

    public void onPause() {
        super.onPause();
        //Toast.makeText(getActivity(), "Pause",Toast.LENGTH_SHORT).show();
        getActivity().unregisterReceiver(receiver);
        ulozStavQuidoViewPref();
    }
/*
    @Override
    public void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        //Toast.makeText(getActivity(), "Save",Toast.LENGTH_LONG).show();
        ulozStavQuidoViewPref();
    }
*/

    private void updateNetworkStatus() {
        if (cm != null) {
            NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
            if (activeNetwork != null && activeNetwork.isAvailable() && activeNetwork.isConnected()) {
                popisQuidoInternetStav.setText("připojeno.");
                popisQuidoInternetStav.setTextColor(textViewQuidoStav.getTextColors());
            } else {
                popisQuidoInternetStav.setText("nepřipojeno.");
                popisQuidoInternetStav.setTextColor(Color.RED);
            }
        }
    }



    public void nastavQuidoButtony(Boolean pozadovanyStav) {
        buttonQuidoStav.setEnabled(pozadovanyStav);
        buttonQuidoVerandaZap.setEnabled(pozadovanyStav);
        buttonQuidoVerandaVyp.setEnabled(pozadovanyStav);
        buttonQuidoVchodZap.setEnabled(pozadovanyStav);
        buttonQuidoVchodVyp.setEnabled(pozadovanyStav);
        buttonQuidoSvetloZap.setEnabled(pozadovanyStav);
        buttonQuidoSvetloVyp.setEnabled(pozadovanyStav);

    }


    public void ulozStavQuidoViewPref() {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        preferences.edit().putString("textViewQuidoHistory", textViewQuidoHistory.getText().toString()).apply();
        preferences.edit().putString("popisQuidoVchodStav", popisQuidoVchodStav.getText().toString()).apply();
        preferences.edit().putString("popisQuidoVerandaStav", popisQuidoVerandaStav.getText().toString()).apply();
        preferences.edit().putString("textViewQuidoStav", textViewQuidoStav.getText().toString()).apply();
   }

    public void obnovStavQuidoViewPref() {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        textViewQuidoHistory.setText(preferences.getString("textViewQuidoHistory", "HISTORIE:"));
        popisQuidoVchodStav.setText(preferences.getString("popisQuidoVchodStav", "neznámé"));
        popisQuidoVerandaStav.setText(preferences.getString("popisQuidoVerandaStav", "neznámé"));
        textViewQuidoStav.setText(preferences.getString("textViewQuidoStav", "Neaktualizováno."));

        if (popisQuidoVchodStav.getText().equals("ZAP")) {popisQuidoVchodStav.setBackgroundColor(0xff00ff00);}
        if (popisQuidoVchodStav.getText().equals("VYP")) {popisQuidoVchodStav.setBackgroundColor(0xffff0000);}
        if (popisQuidoVerandaStav.getText().equals("ZAP")) {popisQuidoVerandaStav.setBackgroundColor(0xff00ff00);}
        if (popisQuidoVerandaStav.getText().equals("VYP")) {popisQuidoVerandaStav.setBackgroundColor(0xffff0000);}
        Boolean butt=preferences.getBoolean("buttons", true);
        nastavQuidoButtony(butt);
    }

    public void zpracujQuidoVysledek (String vysledek) {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //Toast.makeText(getActivity(), toustik, Toast.LENGTH_LONG).show();
        textViewQuidoHistory.setText("HISTORIE:\n");
        Long timestampQuido = preferences.getLong("timestampQuido", 1);
        String currentDateandTime = DateFormat.getDateTimeInstance().format(new Date(timestampQuido));
        if (!vysledek.contains("FAILED") && !vysledek.contains("Neplatn")) {
            textViewQuidoStav.setText("Stav k " + currentDateandTime + ".");
        }
        vysledek = vysledek.replace("=0<BR>", "=VYP");
        vysledek = vysledek.replace("=1<BR>", "=ZAP");
        Integer indexVchod = vysledek.lastIndexOf("VCHOD=");
        Integer indexVeranda = vysledek.lastIndexOf("VERANDA=");
        if (indexVchod > 0) {
            String vchodStav = vysledek.substring(indexVchod + 6, indexVchod + 9);
            popisQuidoVchodStav.setText(vchodStav);
            if (vchodStav.equals("ZAP")) {
                popisQuidoVchodStav.setBackgroundColor(0xff00ff00);
            } else {
                popisQuidoVchodStav.setBackgroundColor(0xffff0000);
            }
        }
        if (indexVeranda > 0) {
            String verandaStav = vysledek.substring(indexVeranda + 8, indexVeranda + 11);
            popisQuidoVerandaStav.setText(verandaStav);
            if (verandaStav.equals("ZAP")) {
                popisQuidoVerandaStav.setBackgroundColor(0xff00ff00);
            } else {
                popisQuidoVerandaStav.setBackgroundColor(0xffff0000);
            }
        }
        String pocetH = preferences.getString("pref_edit_max_history", "5");
        if (vysledek.lastIndexOf("Prezdivka")>0) {
            for (int i = 0; i < Integer.valueOf(pocetH); ++i) {
                Integer indexN = vysledek.indexOf("N" + Integer.toString(i) + "=") + ("N" + Integer.toString(i) + "=").length();
                String n = vysledek.substring(indexN, vysledek.indexOf("<BR>", indexN));
                Integer indexDatum = vysledek.indexOf("Datum" + Integer.toString(i) + "=") + ("Datum" + Integer.toString(i) + "=").length();
                String datum = vysledek.substring(indexDatum, vysledek.indexOf("<BR>", indexDatum));
                Integer indexCas = vysledek.indexOf("Cas" + Integer.toString(i) + "=") + ("Cas" + Integer.toString(i) + "=").length();
                String cas = vysledek.substring(indexCas, vysledek.indexOf("<BR>", indexCas));
                Integer indexPrezdivka = vysledek.indexOf("Prezdivka" + Integer.toString(i) + "=") + ("Prezdivka" + Integer.toString(i) + "=").length();
                String prezdivka = vysledek.substring(indexPrezdivka, vysledek.indexOf("<BR>", indexPrezdivka));
                Integer indexPrikaz = vysledek.indexOf("Prikaz" + Integer.toString(i) + "=") + ("Prikaz" + Integer.toString(i) + "=").length();
                String prikaz = vysledek.substring(indexPrikaz, vysledek.indexOf("<BR>", indexPrikaz));
                textViewQuidoHistory.setText(textViewQuidoHistory.getText() + n + ". " + datum + " " + cas + " " + prezdivka + " " + prikaz + "\n");
            }
        }
        if (vysledek.contains("FAILED")) {
            textViewQuidoHistory.setText(textViewQuidoHistory.getText() + currentDateandTime + ": Chyba komunikace se serverem!" + "\n");
            textViewQuidoStav.setText(preferences.getString("textViewQuidoStavLastOK", "Neaktualizováno."));
            }
        if (vysledek.contains("Neplatn")) {
            textViewQuidoHistory.setText(textViewQuidoHistory.getText() + currentDateandTime + ": Neplatná autorizace!" + "\n");
            textViewQuidoStav.setText(preferences.getString("textViewQuidoStavLastOK", "Neaktualizováno."));

        }
        preferences.edit().putBoolean("progressQuido", false).apply();
    }

}